require "gutenberg_book_finder/version"
require 'nokogiri'
require 'httparty'

module GutenbergBookFinder

  class HtmlParserIncluded < HTTParty::Parser
    SupportedFormats.merge!('text/html' => :html)

    def html
      ::Nokogiri::HTML(body)
    end
  end

  class Page
    include HTTParty
    parser HtmlParserIncluded
  end

  def self.random_id
    page = Page.get 'http://www.gutenberg.org/ebooks/search/?sort_order=random'
    random_id = page.css('.booklink a.link').first.xpath('@href').to_s.split('/').last.to_i
  end

  def self.book_info(id)
    page = Page.get "http://www.gutenberg.org/ebooks/#{id}"
    info = page.css('#content .header h1').text
    title, author = info.split(' by ')
  end

  def self.book_text(id)
    text_url = "http://www.gutenberg.org/cache/epub/#{id}/pg#{id}.txt"
    HTTParty.get(text_url).body
  end
end
